﻿using Infragistics.Controls.Editors;
using Infragistics.Windows;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace MultiComboSearching
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<Person> people;

        public MainWindow()
        {
            InitializeComponent();
            GetData();
            myCombo.ItemsSource = people;
        }
        private void GetData()
        {
            people = new ObservableCollection<Person>();
            people.Add(new Person { Name =  "Stefan", Age = 3 });
            people.Add(new Person { Name = "Dancho", Age = 8 });
            people.Add(new Person { Name = "Ivan", Age = 56 });
            people.Add(new Person { Name = "Petar", Age = 32 });
            people.Add(new Person { Name = "John", Age = 102 });
            people.Add(new Person { Name = "Su", Age = 58 });
            people.Add(new Person { Name = "Georg", Age = 32 });
        }

        private void myCombo_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            TextBox ttb = Utilities.GetDescendantFromName(sender as DependencyObject, "PART_EditableTextBox") as TextBox;
            if (ttb != null)
            {

                (sender as XamMultiColumnComboEditor).IsDropDownOpen = true;
                Dispatcher.BeginInvoke(new Action(() =>
                {
                    var temp22 = ttb.Text.Substring(0, ttb.Text.Length - ttb.SelectionLength);
                    var temp = people.Where(x => x.Name.ToString().ToLowerInvariant().StartsWith(ttb.Text.Substring(0, ttb.Text.Length - ttb.SelectionLength).ToLowerInvariant()));
                    if (temp.Count() == 0)
                    {
                        e.Handled = true;
                    }
                    (sender as XamMultiColumnComboEditor).ItemsSource = people.Where(x => x.Name.ToString().ToLowerInvariant().StartsWith(ttb.Text.Substring(0, ttb.Text.Length - ttb.SelectionLength).ToLowerInvariant()));

                }), System.Windows.Threading.DispatcherPriority.Background, null);

            }
        }
    }

    public class Person : INotifyPropertyChanged
    {
        private string _name;

        public string Name
        {
            get { return _name; }
            set
            {
                _name = value;
                PropChanged("Name");
            }
        }

        private int _age;

        public int Age
        {
            get { return _age; }
            set 
            { 
                _age = value;
                PropChanged("Age");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        
        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
            {
		            PropertyChanged(this,new PropertyChangedEventArgs(name));
            }
        }
    }

				
}

